#include <amxmodx>
#include <amxmisc>
#include <codmod>
#include <fun>
#include <hamsandwich>
#include <fakemeta>
#include <xs>

#define MAX 32

new sprite_fire,
    sprite_smoke;
new ma_perk[MAX+1] , palenie_gracza[MAX+1];

#define DMG_BULLET (1<<1)
        
new bool:ma_klase[33];
	
new const nazwa[]   = "Hardkorowy Lekki Zolnierz";
new const opis[]    = "Nie slychac jego krokow, 10% dodatkowych obrazen z galila, ma 1/5 szansy na podpalenie gracza po strzale, jest odporny na lebshoty.";
new const bronie    = (1<<CSW_GALIL)|(1<<CSW_P228);
new const zdrowie   = 20;
new const kondycja  = 0;
new const inteligencja = 0;
new const wytrzymalosc = 10;
    
public plugin_init()
{
	register_plugin(nazwa, "1.0", "hasztag");

	cod_register_advance(cod_get_classid("Elitarny Lekki Zolnierz"), 120, nazwa, opis, bronie, zdrowie, kondycja, inteligencja, wytrzymalosc);

                  RegisterHam(Ham_TakeDamage, "player", "TakeDamage");

                  register_event("Damage", "Damage", "b", "2!=0");

                  register_forward(FM_TraceLine, "TraceLine");
}

public cod_class_enabled(id)
{
    ma_klase[id] = true;
    set_user_footsteps(id, 1);
}

public cod_class_disabled(id)
{
    ma_klase[id] = false;
    set_user_footsteps(id, 0);
    
}

public TakeDamage(this, idinflictor, idattacker, Float:damage, damagebits){
	
if(!is_user_connected(idattacker))

return HAM_IGNORED;


if(!ma_klase[idattacker])

return HAM_IGNORED;


if(!(damagebits & (1<<1)))

return HAM_IGNORED;


if(get_user_weapon(idattacker) != CSW_GALIL)

return HAM_IGNORED;


cod_inflict_damage(idattacker, this, damage*0.1, 0.0, idinflictor, damagebits);


return HAM_IGNORED;

}

public plugin_precache()
{
    sprite_fire = precache_model("sprites/fire.spr")
    sprite_smoke = precache_model("sprites/steam1.spr")
}

public Damage(id)
{
    new attacker = get_user_attacker(id);
    if(!is_user_alive(attacker))
        return PLUGIN_CONTINUE;
    
    if(ma_klase[attacker] && random_num(1, 5) == 1)
    {
        if(task_exists(id+2936))
            remove_task(id+2936);
        palenie_gracza[id] = 70;
        new data[2]
        data[0] = id
        data[1] = attacker
        set_task(0.8, "burning_flame", id+2936, data, 2, "b");
    }
    return PLUGIN_CONTINUE;
}

public burning_flame(data[2])
{
    new id = data[0]
    
    if(!is_user_alive(id))
    {
        palenie_gracza[id] = 0
        remove_task(id+2936);
        return PLUGIN_CONTINUE;
    }
    
    new origin[3], flags = pev(id, pev_flags)
    get_user_origin(id, origin)
    
    if(flags & FL_INWATER || palenie_gracza[id] < 1 || !get_user_health(id))
    {
        message_begin(MSG_PVS, SVC_TEMPENTITY, origin)
        write_byte(TE_SMOKE)
        write_coord(origin[0])
        write_coord(origin[1])
        write_coord(origin[2]-50)
        write_short(sprite_smoke)
        write_byte(random_num(15,20))
        write_byte(random_num(10,20))
        message_end()
        
        remove_task(id+2936);
        return PLUGIN_CONTINUE;
    }
    
    if(flags & FL_ONGROUND)
    {
        static Float:velocity[3]
        pev(id, pev_velocity, velocity)
        xs_vec_mul_scalar(velocity, 0.5, velocity)
        set_pev(id, pev_velocity, velocity)
    }
    cod_inflict_damage(data[1], id, 3.0, 0.2, 0, 1<<24);
    
    message_begin(MSG_PVS, SVC_TEMPENTITY, origin)
    write_byte(TE_SPRITE)
    write_coord(origin[0]+random_num(-5,5))
    write_coord(origin[1]+random_num(-5,5))
    write_coord(origin[2]+random_num(-10,10))
    write_short(sprite_fire)
    write_byte(random_num(5,10))
    write_byte(200)
    message_end()
    
    palenie_gracza[id]--
    return PLUGIN_CONTINUE;
}   

public TraceLine(Float:start[3], Float:end[3], conditions, id, trace)
{ 
if(get_tr2(trace, TR_iHitgroup) != HIT_HEAD)
return FMRES_IGNORED;

new iHit = get_tr2(trace, TR_pHit);

if(!is_user_connected(iHit))
return FMRES_IGNORED;

if(!ma_klase[iHit])
return FMRES_IGNORED;

set_tr2(trace, TR_iHitgroup, 8);

return FMRES_IGNORED;
}